/**
 * 24 Feb 2012: Modified for CS200 Colorado State Univerisity. 
 *              partition(), getPivot() methods are separately specified
 *              from the original code.
 *              Stand-alone version
 *              Sangmi Lee Pallickara (sangmi@cs.colostate.edu).
 *              Original code is available at,
 *              http://www.cs.ubc.ca/~harrison/Java/QSortAlgorithm.java
 *              
 */  

public class Qsort{
    private int count = 0;
    public Qsort(){
    }

    int getPivot(int a[], int lo0, int hi0){
	// you can modify this part
	return (lo0+hi0)/2;
    }
    int partition(int a[], int lo0, int hi0){
	
        /*
         *  Pick a pivot and move it out of the way
	 *  based on your getPivot() method, you need to change this part.
         */
	int lo = lo0;
	int hi = hi0;
	int pivot_index = getPivot(a, lo, hi);
	int pivot = a[pivot_index];
        a[pivot_index] = a[hi];
        a[hi] = pivot;

        while( lo < hi ) {
            /*
             *  Search forward from a[lo] until an element is found that
             *  is greater than the pivot or lo >= hi 
             */
	    count++;
            while (a[lo] <= pivot && lo < hi) {
		lo++; count++;
	    }

            /*
             *  Search backward from a[hi] until element is found that
             *  is less than the pivot, or lo >= hi
             */
	    count++;
	    while (pivot <= a[hi] && lo < hi ) {
		hi--; count++;
	    }

            /*
             *  Swap elements a[lo] and a[hi]
             */
            if( lo < hi ) {
                int T = a[lo];
                a[lo] = a[hi];
                a[hi] = T;
		count = count+3;
               
            }

	}

        /*
         *  Put the median in the "center" of the list
         */


        a[hi0] = a[hi];
        a[hi] = pivot;

	return hi; 

    }
    void sort(int a[], int lo0, int hi0) throws Exception {
	int lo = lo0;
	int hi = hi0;

	if (lo >= hi) {
	    return;
	}
        else if( lo == hi - 1 ) {
            /*
             *  sort a two element list by swapping if necessary 
             */
            if (a[lo] > a[hi]) {
                int T = a[lo];
                a[lo] = a[hi];
                a[hi] = T;
		count = count+3;
            }
            return;
	}

	int pivot_index = this.partition(a,lo,hi);

        /*
         *  Recursive calls, elements a[lo0] to a[pivot_index-1] are less than or
         *  equal to pivot, elements a[pivot_index+1] to a[hi0] are greater than
         *  pivot.
         */
	sort(a, lo0, pivot_index-1);
	sort(a, pivot_index, hi0);
    }

    void sort(int a[]) throws Exception {
	sort(a, 0, a.length-1);
    }

    public int getCount(){
	return count;
    }

    public static void main (String[] args){
	try{
	    Qsort qs = new Qsort();
	    int[] inputArray = new int[10];
	    inputArray[0] = 22;
	    inputArray[1] = 24;
	    inputArray[2] = 33;
	    inputArray[3] = 12;
	    inputArray[4] = 15;
	    inputArray[5] = 27;
	    inputArray[6] = 21;
	    inputArray[7] = 15;
	    inputArray[8] = 12;
	    inputArray[9] = 24;

	    qs.sort(inputArray);
	    for (int i= 0; i<inputArray.length; i++){		
		System.out.print(inputArray[i]+" ");
	    }
	    System.out.println();
	    System.out.println("Total count: "+qs.getCount());
	}catch (Exception e){
	    e.printStackTrace();
	}
    }
}

